Index: TXM/trunk/bundles/org.txm.rcp/src/main/java/org/txm/rcp/ApplicationWorkbenchAdvisor.java
===================================================================
--- TXM/trunk/bundles/org.txm.rcp/src/main/java/org/txm/rcp/ApplicationWorkbenchAdvisor.java	(revision 3888)
+++ TXM/trunk/bundles/org.txm.rcp/src/main/java/org/txm/rcp/ApplicationWorkbenchAdvisor.java	(revision 3889)
@@ -171,7 +171,7 @@
 
 						monitor.beginTask(TXMUIMessages.startingTxm, 100);
 
-						monitor.setTaskName(TXMUIMessages.loadingTXMInstallPreferences);
+						monitor.setTaskName(TXMUIMessages.loadingTXMInstallPreferencesP0);
 						Log.fine(TXMUIMessages.startJobColonLoadInstallPreferences);
 						if (!checkInstallDirectory(this)) {
 							monitor.done();
@@ -268,7 +268,7 @@
 						monitor.done();
 					}
 					catch (Exception e) {
-						System.out.println(TXMCoreMessages.bind(TXMUIMessages.errorWhileLoadingTXMColon, e));
+						System.out.println(TXMCoreMessages.bind(TXMUIMessages.errorWhileLoadingTXMP0, e));
 						org.txm.utils.logger.Log.printStackTrace(e);
 					}
 					catch (ThreadDeath td) {
@@ -473,12 +473,12 @@
 							handlerService.executeCommand(TXMUpdateHandler.ID, e);
 						}
 						catch (Exception e) {
-							System.out.println(TXMCoreMessages.bind(TXMUIMessages.errorWhileUpdatingTXMColon, e));
+							System.out.println(TXMCoreMessages.bind(TXMUIMessages.errorWhileUpdatingTXMP0, e));
 							Log.printStackTrace(e);
 						}
 					}
 					else {
-						System.out.println(TXMUIMessages.errorWhileUpdatingTXMColonNoHandlerServiceFound);
+						System.out.println(TXMUIMessages.errorWhileUpdatingTXMP0NoHandlerServiceFound);
 					}
 				}
 			});
@@ -711,7 +711,7 @@
 			}
 		}
 		catch (Exception e) {
-			Log.severe(TXMCoreMessages.bind(TXMUIMessages.couldNotReadInstallPreferencesFile, e));
+			Log.severe(TXMCoreMessages.bind(TXMUIMessages.couldNotReadInstallPreferencesFileP0, e));
 			Log.printStackTrace(e);
 			return false;
 		}
@@ -850,8 +850,8 @@
 			}
 			catch (Exception e) {
 				org.txm.utils.logger.Log.printStackTrace(e);
-				System.out.println(TXMCoreMessages.bind(TXMUIMessages.failedToBackupExistingCorporaColon, e.getLocalizedMessage()));
-				Log.severe(TXMCoreMessages.bind(TXMUIMessages.failedToBackupExistingCorporaColon, e.getLocalizedMessage()));
+				System.out.println(TXMCoreMessages.bind(TXMUIMessages.failedToBackupExistingCorporaP0, e.getLocalizedMessage()));
+				Log.severe(TXMCoreMessages.bind(TXMUIMessages.failedToBackupExistingCorporaP0, e.getLocalizedMessage()));
 				return false;
 			}
 
Index: TXM/trunk/bundles/org.txm.cooccurrence.core/src/org/txm/cooccurrence/core/functions/Cooccurrence.java
===================================================================
--- TXM/trunk/bundles/org.txm.cooccurrence.core/src/org/txm/cooccurrence/core/functions/Cooccurrence.java	(revision 3888)
+++ TXM/trunk/bundles/org.txm.cooccurrence.core/src/org/txm/cooccurrence/core/functions/Cooccurrence.java	(revision 3889)
@@ -1189,7 +1189,7 @@
 				}
 			}
 			catch (Exception e) {
-				Log.severe(CooccurrenceCoreMessages.ErrorWhileComputingIndexForTheCooccurrenceP0 + e.getLocalizedMessage());
+				Log.severe(NLS.bind(CooccurrenceCoreMessages.ErrorWhileComputingIndexForTheCooccurrenceP0, e.getLocalizedMessage()));
 				return false;
 			}
 		}
Index: TXM/trunk/bundles/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/RStatsEngine.java
===================================================================
--- TXM/trunk/bundles/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/RStatsEngine.java	(revision 3888)
+++ TXM/trunk/bundles/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/RStatsEngine.java	(revision 3889)
@@ -65,7 +65,7 @@
 			boolean debug = RPreferences.getInstance().getBoolean(RPreferences.DEBUG);
 			mandatory = RPreferences.getInstance().getBoolean(RPreferences.IS_MANDATORY);
 
-			Log.fine(RCoreMessages.bind(RCoreMessages.info_startingStatsEngine, new Object[] { user, remote, port, debug }));
+			Log.fine(RCoreMessages.bind(RCoreMessages.info_startingStatsEngineP0P1P2P3, new Object[] { user, remote, port, debug }));
 			// System.out.println("test remote :" + R_PATH_TO_EXECUTABLE + ":" + properties.getProperty(R_PATH_TO_EXECUTABLE));
 			if (!remote) {
 				// start Rserve executable
Index: TXM/trunk/bundles/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/RScriptEngine.java
===================================================================
--- TXM/trunk/bundles/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/RScriptEngine.java	(revision 3888)
+++ TXM/trunk/bundles/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/RScriptEngine.java	(revision 3889)
@@ -72,7 +72,7 @@
 //				RConsole.printServer(str);
 			RWorkspace.appendtoEvalLog(text);
 
-			System.out.println(TXMCoreMessages.bind(RCoreMessages.doneColon, (System.currentTimeMillis()-time)));
+			System.out.println(TXMCoreMessages.bind(RCoreMessages.doneP0, (System.currentTimeMillis()-time)));
 			
 		} catch(Exception e) {
 			System.out.println(NLS.bind(RCoreMessages.errorWhileRunningRScriptP0ColonP1, text, Log.toString(e))); 
@@ -130,7 +130,7 @@
 //					RConsole.printServer(cmd);
 //			}
 				
-			System.out.println(TXMCoreMessages.bind(RCoreMessages.doneColon, (System.currentTimeMillis()-time)));
+			System.out.println(TXMCoreMessages.bind(RCoreMessages.doneP0, (System.currentTimeMillis()-time)));
 			
 		} catch(Exception e) {
 			System.out.println(NLS.bind(RCoreMessages.errorWhileRunningRScriptP0ColonP1, rFile, e.getMessage())); 
Index: TXM/trunk/bundles/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/RWorkspace.java
===================================================================
--- TXM/trunk/bundles/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/RWorkspace.java	(revision 3888)
+++ TXM/trunk/bundles/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/RWorkspace.java	(revision 3889)
@@ -190,7 +190,7 @@
 	 */
 	public static boolean connect(String host, int port) throws RWorkspaceException {
 		try {
-			Log.fine(RCoreMessages.bind(RCoreMessages.info_connectingToRAt, host, port));
+			Log.fine(RCoreMessages.bind(RCoreMessages.info_connectingToRAtP0P1, host, port));
 			connection = new RConnection(host, port);
 			connection.setStringEncoding("utf8"); // mandatory ! //$NON-NLS-1$
 			return isConnected();
@@ -212,7 +212,7 @@
 	 */
 	public static boolean connect(String host, int port, String user, String password) {
 		try {
-			Log.fine(TXMCoreMessages.bind(RCoreMessages.info_connectingToRAtWithUser, new Object[] { host, port, user }));
+			Log.fine(TXMCoreMessages.bind(RCoreMessages.info_connectingToRAtP0P1WithUserP2, new Object[] { host, port, user }));
 			connection = new RConnection(host, port);
 			connection.login(user, password);
 			connection.setStringEncoding("utf8"); // mandatory ! //$NON-NLS-1$
@@ -220,7 +220,7 @@
 			
 		}
 		catch (RserveException x) {
-			Log.severe(TXMCoreMessages.bind(RCoreMessages.error_failedToConnectToTheRWorkspace, host, port, user));
+			Log.severe(TXMCoreMessages.bind(RCoreMessages.error_failedToConnectToTheRWorkspaceP0AtP1WithUserP2, host, port, user));
 		}
 		return false;
 	}
@@ -279,7 +279,7 @@
 				// System.out.println("Done : load R lib : " + name);
 			}
 			catch (RserveException e) {
-				throw new RWorkspaceException(NLS.bind(RCoreMessages.error_failedToLoadLibrary, name, e));
+				throw new RWorkspaceException(NLS.bind(RCoreMessages.error_failedToLoadTheP0LibraryP1, name, e));
 			}
 			catch (Exception e) {
 				org.txm.utils.logger.Log.printStackTrace(e);
@@ -311,13 +311,13 @@
 			throw new RWorkspaceException(RCoreMessages.error_rservePathNotSet);
 		}
 		else if (!execFile.exists()) {
-			throw new RWorkspaceException(RCoreMessages.bind(RCoreMessages.error_cantFindRServeInPath, pathToRExecutable));
+			throw new RWorkspaceException(RCoreMessages.bind(RCoreMessages.error_cantFindRServeInTheP0Path, pathToRExecutable));
 		}
 		else if (!execFile.isFile()) {
-			throw new RWorkspaceException(RCoreMessages.bind(RCoreMessages.error_RservePathNotPointingAFile, pathToRExecutable));
+			throw new RWorkspaceException(RCoreMessages.bind(RCoreMessages.error_P0RservePathNotPointingAFile, pathToRExecutable));
 		}
 		else if (!execFile.canExecute()) {
-			throw new RWorkspaceException(RCoreMessages.bind(RCoreMessages.error_cantExecuteRServe, pathToRExecutable));
+			throw new RWorkspaceException(RCoreMessages.bind(RCoreMessages.error_cantExecuteTheP0RServeFile, pathToRExecutable));
 		}
 		else {
 			isRServerOk = StartRserve.launchRserve(pathToRExecutable, port, debug, rargs, rServeArgs);
@@ -462,7 +462,7 @@
 	 * Prints the last safe eval expr.
 	 */
 	public static void printLastSafeEvalExpr() {
-		Log.fine(RCoreMessages.bind(RCoreMessages.info_lastSafeEvalExpression, lastSafeevalExpr));
+		Log.fine(RCoreMessages.bind(RCoreMessages.info_lastSafeEvalExpressionP0, lastSafeevalExpr));
 	}
 	
 	/**
@@ -493,7 +493,7 @@
 			}
 			catch (IOException e) {
 				filecommunication = false;
-				Log.severe(RCoreMessages.bind(RCoreMessages.error_failedToInitializeFileTransfert, Log.toString(e)));
+				Log.severe(RCoreMessages.bind(RCoreMessages.error_failedToInitializeFileTransfertP0, Log.toString(e)));
 				return false;
 			}
 		}
@@ -963,7 +963,7 @@
 			}
 			else {
 				if (!containsVariable(arguments[i].getSymbol())) {
-					throw new RWorkspaceException(NLS.bind(RCoreMessages.error_requestedObjectNotFoundInR, arguments[i].getSymbol()));
+					throw new RWorkspaceException(NLS.bind(RCoreMessages.error_requestedP0ObjectNotFoundInR, arguments[i].getSymbol()));
 				}
 				arguments_as_string[i] = arguments[i].getSymbol();
 			}
@@ -1639,7 +1639,7 @@
 			
 		}
 		catch (RserveException e) {
-			System.out.println(NLS.bind(RCoreMessages.error_evaluationError, e.getMessage(), exp));
+			System.out.println(NLS.bind(RCoreMessages.error_evaluationErrorP0P1, e.getMessage(), exp));
 			Log.printStackTrace(e);
 		}
 		catch (Exception e) {
Index: TXM/trunk/bundles/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/StartRserve.java
===================================================================
--- TXM/trunk/bundles/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/StartRserve.java	(revision 3888)
+++ TXM/trunk/bundles/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/StartRserve.java	(revision 3889)
@@ -140,7 +140,7 @@
 			// Rserveprocess = builder.start();
 			
 			Runtime runtime = Runtime.getRuntime();
-			Log.fine(RCoreMessages.bind(RCoreMessages.info_startingRWithCommandLine, StringUtils.join(cmdline, " "))); //$NON-NLS-1$
+			Log.fine(RCoreMessages.bind(RCoreMessages.info_startingRWithCommandLineP0, StringUtils.join(cmdline, " "))); //$NON-NLS-1$
 			rProcess = runtime.exec(cmdline);
 			
 			// Log.info(Messages.StartRserve_0+Arrays.toString(cmdline));
@@ -203,7 +203,7 @@
 	protected static boolean checkLocalRserve(int port, boolean debug, String rargs, String rServeArgs) {
 		Log.fine(RCoreMessages.info_rPathNotSetTryingToFindIt);
 		if (isRserveRunning(port)) {
-			Log.fine(NLS.bind(RCoreMessages.error_rserveIsAlreadyRunningOnPort, port));
+			Log.fine(NLS.bind(RCoreMessages.error_rserveIsAlreadyRunningOnTheP0Port, port));
 			return true;
 		}
 		// Windows OS
@@ -247,7 +247,7 @@
 		
 		for (String path : paths) {
 			File execFile = new File(path);
-			Log.fine(RCoreMessages.bind(RCoreMessages.info_tryingToStartRFrom, path));
+			Log.fine(RCoreMessages.bind(RCoreMessages.info_tryingToStartRFromP0, path));
 			if (execFile.exists() && launchRserve(path, port, debug, rargs, rServeArgs)) {
 				return true;
 			}
Index: TXM/trunk/bundles/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/messages/RCoreMessages.java
===================================================================
--- TXM/trunk/bundles/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/messages/RCoreMessages.java	(revision 3888)
+++ TXM/trunk/bundles/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/messages/RCoreMessages.java	(revision 3889)
@@ -14,21 +14,21 @@
 	
 	private static final String BUNDLE_NAME = "org.txm.statsengine.r.core.messages.messages"; //$NON-NLS-1$
 	
-	public static String error_cantFindRServeInPath;
+	public static String error_cantFindRServeInTheP0Path;
 	
 	public static String error_connectionFailed;
 	
 	public static String error_errorDuringItemsListExtraction;
 	
-	public static String error_errorWhileEvaluating;
+	public static String error_errorP0WhileEvaluatingP1;
 	
-	public static String error_evaluationError;
+	public static String error_evaluationErrorP0P1;
 	
-	public static String error_failedToConnectToTheRWorkspace;
+	public static String error_failedToConnectToTheRWorkspaceP0AtP1WithUserP2;
 	
-	public static String error_failedToInitializeFileTransfert;
+	public static String error_failedToInitializeFileTransfertP0;
 	
-	public static String error_failedToLoadLibrary;
+	public static String error_failedToLoadTheP0LibraryP1;
 	
 	public static String error_failedToRunREG;
 	
@@ -38,37 +38,37 @@
 	
 	public static String error_matrixIsEmpty;
 	
-	public static String error_requestedObjectNotFoundInR;
+	public static String error_requestedP0ObjectNotFoundInR;
 	
-	public static String error_rserveIsAlreadyRunningOnPort;
+	public static String error_rserveIsAlreadyRunningOnTheP0Port;
 	
 	public static String error_rservePathNotSet;
 	
 	public static String error_youNeedRSoftware;
 	
-	public static String info_connectingToRAt;
+	public static String info_connectingToRAtP0P1;
 	
-	public static String info_connectingToRAtWithUser;
+	public static String info_connectingToRAtP0P1WithUserP2;
 	
-	public static String info_lastSafeEvalExpression;
+	public static String info_lastSafeEvalExpressionP0;
 	
 	public static String info_rPathNotSetTryingToFindIt;
 	
-	public static String info_savingChartToFile;
+	public static String info_savingChartToTheP0File;
 	
-	public static String info_startingRWithCommandLine;
+	public static String info_startingRWithCommandLineP0;
 	
-	public static String info_startingStatsEngine;
+	public static String info_startingStatsEngineP0P1P2P3;
 	
 	public static String info_statisticsEngineLaunched;
 	
-	public static String info_tryingToStartRFrom;
+	public static String info_tryingToStartRFromP0;
 	
 	public static String info_tryingToStartRWithRPath;
 	
 	public static String runningP0;
 	
-	public static String doneColon;
+	public static String doneP0;
 	
 	public static String runningTextSelection;
 	
@@ -76,13 +76,13 @@
 	
 	public static String p0RScriptDoesntExist;
 	
-	public static String error_unexpectedErrorInRStatisticsEngine;
+	public static String error_unexpectedErrorInRStatisticsEngineP0;
 	
 	public static String rserveNotStartedUsingTheP0Path;
 	
-	public static String error_cantExecuteRServe;
+	public static String error_cantExecuteTheP0RServeFile;
 	
-	public static String error_RservePathNotPointingAFile;
+	public static String error_P0RservePathNotPointingAFile;
 	
 	static {
 		// initialize resource bundle
Index: TXM/trunk/bundles/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/data/MatrixImpl.java
===================================================================
--- TXM/trunk/bundles/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/data/MatrixImpl.java	(revision 3888)
+++ TXM/trunk/bundles/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/data/MatrixImpl.java	(revision 3889)
@@ -483,7 +483,7 @@
 			// System.out.println("nrow: " + nrow);
 			// System.out.println("ncol: " + ncol);
 			// System.out.println(rw.eval("print(" + getSymbol() + ");"));
-			throw new IllegalArgumentException(StatsEngineCoreMessages.bind(StatsEngineCoreMessages.unknownTypeColon, r.getAttribute(StatsEngineCoreMessages.mode)));
+			throw new IllegalArgumentException(StatsEngineCoreMessages.bind(StatsEngineCoreMessages.unknownTypeP0, r.getAttribute(StatsEngineCoreMessages.mode)));
 		}
 	}
 	
@@ -568,7 +568,7 @@
 			return RWorkspace.getRWorkspaceInstance().eval("dim(" + symbol + ")[1]").asInteger(); //$NON-NLS-1$ //$NON-NLS-2$
 		}
 		catch (Exception e) {
-			Log.severe(StatsEngineCoreMessages.bind(StatsEngineCoreMessages.matrixColonFailedToGetNrowColon, e));
+			Log.severe(StatsEngineCoreMessages.bind(StatsEngineCoreMessages.matrixColonFailedToGetNrowP0, e));
 		}
 		return 0;
 	}
Index: TXM/trunk/bundles/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/exceptions/RException.java
===================================================================
--- TXM/trunk/bundles/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/exceptions/RException.java	(revision 3888)
+++ TXM/trunk/bundles/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/exceptions/RException.java	(revision 3889)
@@ -64,7 +64,7 @@
 	 * @param msg the msg
 	 */
 	public RException(String expr, String msg) {
-		super(RCoreMessages.bind(RCoreMessages.error_errorWhileEvaluating, msg, expr));
+		super(RCoreMessages.bind(RCoreMessages.error_errorP0WhileEvaluatingP1, msg, expr));
 		
 	}
 
Index: TXM/trunk/bundles/org.txm.index.rcp/src/org/txm/index/rcp/handlers/SendIndexTo.java
===================================================================
--- TXM/trunk/bundles/org.txm.index.rcp/src/org/txm/index/rcp/handlers/SendIndexTo.java	(revision 3888)
+++ TXM/trunk/bundles/org.txm.index.rcp/src/org/txm/index/rcp/handlers/SendIndexTo.java	(revision 3889)
@@ -33,10 +33,8 @@
 import org.eclipse.ui.handlers.HandlerUtil;
 import org.txm.core.results.TXMResult;
 import org.txm.index.core.functions.Index;
-import org.txm.index.core.preferences.IndexPreferences;
 import org.txm.links.rcp.handlers.SendSelectionToQueryable;
 import org.txm.rcp.editors.TXMEditor;
-import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 import org.txm.searchengine.cqp.corpus.CQPCorpus;
 import org.txm.searchengine.cqp.corpus.Subcorpus;
 import org.txm.searchengine.cqp.corpus.query.CQLQuery;
Index: TXM/trunk/bundles/org.txm.statsengine.r.rcp/src/org/txm/statsengine/r/rcp/messages/RUIMessages.java
===================================================================
--- TXM/trunk/bundles/org.txm.statsengine.r.rcp/src/org/txm/statsengine/r/rcp/messages/RUIMessages.java	(revision 3888)
+++ TXM/trunk/bundles/org.txm.statsengine.r.rcp/src/org/txm/statsengine/r/rcp/messages/RUIMessages.java	(revision 3889)
@@ -67,7 +67,7 @@
 
 	public static String TheP0PackageIsNotInstalledTryingToInstallItNow;
 
-	public static String TheP0PackageWasNotInstalledCorrecltyPleaseInstallItManually;
+	public static String TheP0PackageWasNotInstalledCorrecltyPleaseInstallItManuallyWithCmdP1;
 
 	public static String TryingToInstallTheP0DependencyOfP1Now; 
 	public static String tXMNameP0SupSupRNameP1; 
Index: TXM/trunk/bundles/org.txm.statsengine.r.rcp/src/org/txm/statsengine/r/rcp/handlers/CheckRPackages.java
===================================================================
--- TXM/trunk/bundles/org.txm.statsengine.r.rcp/src/org/txm/statsengine/r/rcp/handlers/CheckRPackages.java	(revision 3888)
+++ TXM/trunk/bundles/org.txm.statsengine.r.rcp/src/org/txm/statsengine/r/rcp/handlers/CheckRPackages.java	(revision 3889)
@@ -166,7 +166,7 @@
 						}
 						catch (Exception e) {
 							Log.printStackTrace(e);
-							Log.warning(TXMCoreMessages.bind(RUIMessages.TheP0PackageWasNotInstalledCorrecltyPleaseInstallItManually, p, p));
+							Log.warning(TXMCoreMessages.bind(RUIMessages.TheP0PackageWasNotInstalledCorrecltyPleaseInstallItManuallyWithCmdP1, p, p));
 							ret = false;
 						}
 					}
Index: TXM/trunk/bundles/org.txm.internalview.rcp/src/org/txm/internalview/rcp/handlers/BackToInternalView.java
===================================================================
--- TXM/trunk/bundles/org.txm.internalview.rcp/src/org/txm/internalview/rcp/handlers/BackToInternalView.java	(revision 3888)
+++ TXM/trunk/bundles/org.txm.internalview.rcp/src/org/txm/internalview/rcp/handlers/BackToInternalView.java	(revision 3889)
@@ -1,6 +1,7 @@
 package org.txm.internalview.rcp.handlers;
 
 import java.util.ArrayList;
+import java.util.Arrays;
 import java.util.List;
 
 import org.eclipse.e4.ui.workbench.modeling.EModelService;
@@ -16,6 +17,7 @@
 import org.txm.rcp.editors.TXMResultEditorInput;
 import org.txm.rcp.utils.SWTEditorsUtils;
 import org.txm.searchengine.cqp.corpus.CQPCorpus;
+import org.txm.searchengine.cqp.corpus.StructuralUnit;
 import org.txm.searchengine.cqp.corpus.StructuralUnitProperty;
 import org.txm.searchengine.cqp.corpus.WordProperty;
 import org.txm.searchengine.cqp.corpus.query.Match;
@@ -23,20 +25,28 @@
 
 public class BackToInternalView {
 	
-	public void doit(TXMEditor<? extends TXMResult> sourceEditor, CQPCorpus corpus, Match match, List<WordProperty> props) {
+	public void doit(TXMEditor<? extends TXMResult> sourceEditor, CQPCorpus corpus, Match match, List<WordProperty> props, StructuralUnit structuralUnit, List<StructuralUnitProperty> structuralUnitProperties) {
 		// Last resort edition
 		try {
+			if (structuralUnit == null) {
+				structuralUnit = corpus.getStructuralUnit(TBXPreferences.DEFAULT_STRUCTURAL_UNIT);
+			}
+			
+			if (props == null || props.size() == 0) {
+				props = Arrays.asList(corpus.getWordProperty());
+			}
+			
 			InternalView iview = new InternalView(corpus);
-			iview.setParameters(props,
-					corpus.getStructuralUnit(TBXPreferences.DEFAULT_STRUCTURAL_UNIT),
-					new ArrayList<StructuralUnitProperty>(), null);
+			iview.setParameters(props, structuralUnit, structuralUnitProperties, null);
 			
 			TXMResultEditorInput<InternalView> editorInput = new TXMResultEditorInput<InternalView>(iview);
 			
 			IWorkbenchPage page = TXMWindows.getActiveWindow().getActivePage();
 			
-			InternalViewEditor editor = (InternalViewEditor) page.openEditor(editorInput, InternalViewEditor.class.getName()); // $NON-NLS-1$
-			editor.backToText(match);
+			InternalViewEditor editor = (InternalViewEditor) page.openEditor(editorInput, InternalViewEditor.class.getName());
+			if (match != null) { // FIXME should not work the editor is not ready to navigate. Move this to the InternalView parameters set before
+				editor.backToText(match);
+			}
 			if (editor != null) {
 				int position = -2;
 				if (position == -2) {
Index: TXM/trunk/bundles/org.txm.queryindex.rcp/src/org/txm/queryindex/rcp/editors/QueryIndexEditor.java
===================================================================
--- TXM/trunk/bundles/org.txm.queryindex.rcp/src/org/txm/queryindex/rcp/editors/QueryIndexEditor.java	(revision 3888)
+++ TXM/trunk/bundles/org.txm.queryindex.rcp/src/org/txm/queryindex/rcp/editors/QueryIndexEditor.java	(revision 3889)
@@ -381,7 +381,7 @@
 					catch (Exception e) {
 						System.out.println(e.getLocalizedMessage());
 						try {
-							Log.severe(TXMCoreMessages.bind(CQPSearchEngineCoreMessages.lastCQPErrorColon, CQPSearchEngine.getCqiClient().getLastCQPError()));
+							Log.severe(TXMCoreMessages.bind(CQPSearchEngineCoreMessages.lastCQPErrorP0, CQPSearchEngine.getCqiClient().getLastCQPError()));
 						}
 						catch (Exception e1) {
 							Log.severe(TXMCoreMessages.bind(CQPSearchEngineCoreMessages.cQPErrorColonP0, e1));
Index: TXM/trunk/bundles/org.txm.searchengine.core/src/org/txm/searchengine/core/Query.java
===================================================================
--- TXM/trunk/bundles/org.txm.searchengine.core/src/org/txm/searchengine/core/Query.java	(revision 3888)
+++ TXM/trunk/bundles/org.txm.searchengine.core/src/org/txm/searchengine/core/Query.java	(revision 3889)
@@ -30,6 +30,7 @@
 import java.util.ArrayList;
 import java.util.List;
 
+import org.eclipse.osgi.util.NLS;
 import org.txm.core.preferences.TXMPreferences;
 import org.txm.searchengine.core.messages.Messages;
 import org.txm.utils.logger.Log;
@@ -115,7 +116,7 @@
 				String eName = split[i+1];
 				SearchEngine e = SearchEnginesManager.getSearchEngine(eName);
 				if (e == null) {
-					Log.warning(Messages.ErrorUnknownSearchEngineP0+eName);
+					Log.warning(NLS.bind(Messages.ErrorUnknownSearchEngineP0, eName));
 					continue;
 				}
 				
Index: TXM/trunk/bundles/org.txm.searchengine.core/src/org/txm/searchengine/core/QueryHistory.java
===================================================================
--- TXM/trunk/bundles/org.txm.searchengine.core/src/org/txm/searchengine/core/QueryHistory.java	(revision 3888)
+++ TXM/trunk/bundles/org.txm.searchengine.core/src/org/txm/searchengine/core/QueryHistory.java	(revision 3889)
@@ -7,6 +7,7 @@
 import java.util.ArrayList;
 import java.util.LinkedHashSet;
 
+import org.eclipse.osgi.util.NLS;
 import org.txm.core.preferences.TBXPreferences;
 import org.txm.core.results.TXMParameters;
 import org.txm.core.results.TXMResult;
@@ -73,7 +74,7 @@
 	@Override
 	public String getDetails() {
 
-		return Messages.QueryHistoryOfP0+queries.size();
+		return NLS.bind(Messages.QueryHistoryOfP0, queries.size());
 	}
 
 	@Override
Index: TXM/trunk/bundles/org.txm.searchengine.core/src/org/txm/searchengine/core/SearchEngine.java
===================================================================
--- TXM/trunk/bundles/org.txm.searchengine.core/src/org/txm/searchengine/core/SearchEngine.java	(revision 3888)
+++ TXM/trunk/bundles/org.txm.searchengine.core/src/org/txm/searchengine/core/SearchEngine.java	(revision 3889)
@@ -2,6 +2,7 @@
 
 import java.util.List;
 
+import org.eclipse.osgi.util.NLS;
 import org.txm.core.results.TXMResult;
 import org.txm.objects.CorpusBuild;
 import org.txm.objects.Match;
@@ -16,7 +17,7 @@
 	public abstract String getName();
 	
 	public boolean start() throws Exception {
-		return start(new LogMonitor(Messages.startingP0+getName()));
+		return start(new LogMonitor(NLS.bind(Messages.startingP0, getName())));
 	}
 	
 	public abstract Selection query(CorpusBuild corpus, IQuery query, String name, boolean saveQuery) throws Exception;
Index: TXM/trunk/bundles/org.txm.treesearch.rcp/src/org/txm/treesearch/command/SendToTreeSearch.java
===================================================================
--- TXM/trunk/bundles/org.txm.treesearch.rcp/src/org/txm/treesearch/command/SendToTreeSearch.java	(revision 3888)
+++ TXM/trunk/bundles/org.txm.treesearch.rcp/src/org/txm/treesearch/command/SendToTreeSearch.java	(revision 3889)
@@ -126,7 +126,7 @@
 			return null;
 		}
 		
-		return toTree(editor, s, kp, editor.getCorpus());
+		return toTree(editor, kp, editor.getCorpus());
 	}
 	
 	public Object concordancetoTree(ITXMResultEditor<? extends TXMResult> editor, ISelection s) {
@@ -161,11 +161,18 @@
 	
 		int kp = l.getKeywordPosition();
 		
-		return toTree(editor, s, kp, concordance.getCorpus());
+		return toTree(editor, kp, concordance.getCorpus());
 	}
 	
+	/**
+	 * 
+	 * @param editor the source editor
+	 * @param kp the token position to focus
+	 * @param corpus the parent corpus to use
+	 * @return
+	 */
 	@SuppressWarnings("unused")
-	public Object toTree(ITXMResultEditor<? extends TXMResult> editor, ISelection s, int kp, CQPCorpus corpus) {
+	public Object toTree(ITXMResultEditor<? extends TXMResult> editor, int kp, CQPCorpus corpus) {
 		TXMResult r = editor.getResult();
 		
 		//TreeSearchSelector selector = ComputeTreeSearch.getSelectorForCorpus(concordance.getCorpus(), "UD");
Index: TXM/trunk/bundles/org.txm.core/src/java/org/txm/core/messages/TXMCoreMessages.java
===================================================================
--- TXM/trunk/bundles/org.txm.core/src/java/org/txm/core/messages/TXMCoreMessages.java	(revision 3888)
+++ TXM/trunk/bundles/org.txm.core/src/java/org/txm/core/messages/TXMCoreMessages.java	(revision 3889)
@@ -246,14 +246,6 @@
 	
 	public static String matchesFound;
 	
-	public static String mergeColsColonP0;
-
-	public static String mergeOrDeleteColumns;
-
-	public static String mergeOrDeleteRows;
-
-	public static String mergingLines;
-
 	public static String noValuesGiven;
 	
 	public static String noWorkspaceFoundCreatingANewOneP0;
@@ -262,7 +254,7 @@
 	
 	public static String numberOfSubMatch;
 	
-	public static String orTheEngineWasNotStartedWithTheCommandLineColon;
+	public static String orTheEngineWasNotStartedWithTheCommandLineColonP0;
 	
 	public static String pARAMSColonP0;
 	
@@ -306,7 +298,6 @@
 	
 	public static String theP0PartFocusDoesntBelongToPartitionP1;
 
-	public static String tP0vP1fminP2fmaxP3;
 	
 	public static String txmDirectoryIsMissingColonP0;
 	
@@ -320,7 +311,7 @@
 	
 	public static String warningColonQueryFailedColonP0;
 	
-	public static String wrongLoginOrPasswordOrPortColon;
+	public static String wrongLoginOrPasswordOrPortColonP0P1P203;
 	
 	public static String xmlValidationColonP0DoesNotExists;
 	
Index: TXM/trunk/bundles/org.txm.internalview.core/src/org/txm/internalview/core/functions/InternalView.java
===================================================================
--- TXM/trunk/bundles/org.txm.internalview.core/src/org/txm/internalview/core/functions/InternalView.java	(revision 3888)
+++ TXM/trunk/bundles/org.txm.internalview.core/src/org/txm/internalview/core/functions/InternalView.java	(revision 3889)
@@ -75,6 +75,11 @@
 	@Parameter(key = TXMPreferences.STRUCTURAL_UNIT_PROPERTIES)
 	protected List<StructuralUnitProperty> pStructuralUnitsProperties;
 	
+	/**
+	 * The number of the structural unit to show
+	 */
+	@Parameter(key = TXMPreferences.INDEX, type=Parameter.RENDERING)
+	protected Integer pIndex;
 	
 	/**
 	 * 
Index: TXM/trunk/bundles/org.txm.chartsengine.r.core/src/org/txm/stat/engine/r/RWorkspaceRenderer.java
===================================================================
--- TXM/trunk/bundles/org.txm.chartsengine.r.core/src/org/txm/stat/engine/r/RWorkspaceRenderer.java	(revision 3888)
+++ TXM/trunk/bundles/org.txm.chartsengine.r.core/src/org/txm/stat/engine/r/RWorkspaceRenderer.java	(revision 3889)
@@ -114,7 +114,7 @@
 		String devicename = device.getName();
 		
 		String name;
-		Log.info(RCoreMessages.bind(RCoreMessages.info_savingChartToFile, file.getAbsolutePath()));
+		Log.info(RCoreMessages.bind(RCoreMessages.info_savingChartToTheP0File, file.getAbsolutePath()));
 		if (OSDetector.isFamilyWindows()) {
 			try {
 				name = StringEscapeUtils.escapeJava(file.getCanonicalPath());
Index: TXM/trunk/bundles/org.txm.tigersearch.rcp/src/org/txm/tigersearch/editors/TSIndexEditor.java
===================================================================
--- TXM/trunk/bundles/org.txm.tigersearch.rcp/src/org/txm/tigersearch/editors/TSIndexEditor.java	(revision 3888)
+++ TXM/trunk/bundles/org.txm.tigersearch.rcp/src/org/txm/tigersearch/editors/TSIndexEditor.java	(revision 3889)
@@ -374,7 +374,7 @@
 							message = ("one result");
 						}
 						else if (index.getV() > 0) {
-							message = (IndexUIMessages.bind(TXMUIMessages.doneColonP0Items, index.getV(), index.getT()));
+							message = (IndexUIMessages.bind(TXMUIMessages.doneColonP0ItemsAndP1Occ, index.getV(), index.getT()));
 						}
 						else {
 							message = (IndexUIMessages.IndexEditor_17);
@@ -421,7 +421,7 @@
 					catch (Exception e) {
 						System.out.println(e.getLocalizedMessage());
 						try {
-							Log.warning(NLS.bind(CQPSearchEngineCoreMessages.lastCQPErrorColon, CQPSearchEngine.getCqiClient().getLastCQPError()));
+							Log.warning(NLS.bind(CQPSearchEngineCoreMessages.lastCQPErrorP0, CQPSearchEngine.getCqiClient().getLastCQPError()));
 						}
 						catch (Exception e1) {
 							Log.warning(CQPSearchEngineCoreMessages.bind(CQPSearchEngineCoreMessages.cQPErrorColonP0, e1));
